variables:
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  MAVEN_CLI_OPTS: "--show-version --batch-mode -e"
  GRADLE_OPTS: "-Dorg.gradle.daemon=false"

before_script:
  - export GRADLE_USER_HOME=`pwd`/.gradle

stages:
  - build
  - test
  - deploy

.build_base: &build_base
  stage: build
  image: gradle:6.5-jdk11
  script:
    - "gradle $GRADLE_OPTS --build-cache assemble"
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: push
    paths:
      - .m2/repository
      - build
      - .gradle
  artifacts:
    paths:
      - build/libs/nl.suitless.cdn-service-0.0.1-SNAPSHOT.jar

.test_base: &test_base
  stage: test
  image: gradle:6.5-jdk11
  script:
    - "gradle $GRADLE_OPTS check"
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: pull
    paths:
      - .m2/repository
      - build
      - .gradle

.docker_base: &docker_base
  stage: deploy
  image: tmaier/docker-compose:latest
  retry: 2
  before_script:
    - "docker info"
  script:
    - "docker login registry.develop.suitless.nl -u $SUITLESS_DOCKER_ID -p $SUITLESS_DOCKER_PASSWORD"
    - "docker build -t registry.develop.suitless.nl/cdn-service:latest -t registry.develop.suitless.nl/cdn-service:$CI_COMMIT_SHORT_SHA -f Dockerfile ."
    - "docker push registry.develop.suitless.nl/cdn-service:latest"
    - "docker push registry.develop.suitless.nl/cdn-service:$CI_COMMIT_SHORT_SHA"
    - "docker stack deploy --compose-file=docker-compose.yml cdn-service"
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: pull
    paths:
      - .m2/repository
      - build
      - .gradle

build_prod:
  <<: *build_base
  only:
    refs:
      - master
      - tags
  except:
    - branches
  tags:
    - production

build_dev:
  <<: *build_base
  except:
    refs:
      - master
      - tags
  tags:
    - dev

test:
  tags:
    - dev
  <<: *test_base

docker_prod:
  <<: *docker_base
  only:
    refs:
      - master
      - tags
  except:
    - branches
  tags:
    - production
  variables:
    ENV: "production"
    URL: "api.suitless.nl"

docker_dev:
  <<: *docker_base
  except:
    refs:
      - master
      - tags
  only:
    refs:
      - develop
  tags:
    - dev
  variables:
    ENV: "develop"
    URL: "api.develop.suitless.nl"
